registerOutputEvent("fxDtsBrick", "sendPathCam", "string 100 100" TAB "list North 0 East 1 South 2 West 3 Up 4 Down 5 Brick 6" TAB "string 100 100" TAB "float 0.1 25 0.1 2.0",1);
registerInputEvent("fxDtsBrick", "onPathCameraReceived", "Self fxDtsBrick" TAB "Player Player" TAB "Client GameConnection" TAB "MiniGame MiniGame");

function fxDtsBrick::sendPathCam(%this,%name,%dir,%name2,%speed,%client)
{
	%found = 0;
	%newBrick = %this.client.brickGroup.NTobject_[%name, 0];
	if(!isObject(%newBrick) || %client.isCamBusy || !isObject(%client.player))
	{
		return;
	}
	cancel(%client.setCOSched);
	if(PathCamSO.numCams > 0)
	{
		for(%i=1;%i<=PathCamSO.numCams;%i++)
		{
			%currCam = PathCamSO.cam[%i];
			if(!%currCam.isBusy)
			{
				%found = 1;
				break;
			}
		}
		if(%found)
		{
			%currCam.setPosition(0.0);
			%currCam.reset();
			for(%a=1;%a<=%currCam.nodeNum;%a++)
			{
				%currCam.node[%a] = "";
			}
			%pathCam = %currCam;
		}
	}
	if(!%found)
	{
		PathCamSO.cam[PathCamSO.numCams++] = new PathCamera()
		{
			dataBlock = PathObserver;
			position = %this.getPosition();
			rotation = "0 0 1 0";
			hasBeenUsed = 0;
		};
		%pathCam = PathCamSO.cam[PathCamSO.numCams];
	}
	switch(%dir)
	{
		case 0: //North
			%transform = %this.getPosition() SPC eulerToAxis("0 0 0");
			%transform2 = %newBrick.getPosition() SPC eulerToAxis("0 0 0");
		case 1: //East
			%transform = %this.getPosition() SPC eulerToAxis("0 0 -90");
			%transform2 = %newBrick.getPosition() SPC eulerToAxis("0 0 -90");
		case 2: //South
			%transform = %this.getPosition() SPC eulerToAxis("0 0 -180");
			%transform2 = %newBrick.getPosition() SPC eulerToAxis("0 0 -180");
		case 3: //West
			%transform = %this.getPosition() SPC eulerToAxis("0 0 -270");
			%transform2 = %newBrick.getPosition() SPC eulerToAxis("0 0 -270");
		case 4: //Up
			%transform = %this.getPosition() SPC eulerToAxis("90 0 0");
			%transform2 = %newBrick.getPosition() SPC eulerToAxis("90 0 0");
		case 5: //Down
			%transform = %this.getPosition() SPC eulerToAxis("-90 0 0");
			%transform2 = %newBrick.getPosition() SPC eulerToAxis("-90 0 0");
		case 6: //Brick
			if(!isObject(%brickLook = %this.client.brickGroup.NTobject_[%name2, 0]))
			{
				%brickLook = %newBrick;
				%transform2 = %newBrick.getPosition() SPC rotBetween(%this.getPosition(),%brickLook.getPosition());
			}
			else
			{
				%transform2 = %newBrick.getPosition() SPC rotBetween(%newBrick.getPosition(),%brickLook.getPosition());
			}
			if(%client.lastDestBrick == %this && getSimTime() - %client.lastPathTrip >= 100)
			{
				%transform = %client.lastDestLook;
			}
			else
			{
				if($PathCam::LightExit)
				{
					messageclient(%client,'',"\c2Starting up path camera. \c6-Use Light key to exit the path.");
				}
				%transform = %this.getPosition() SPC rotBetween(%this.getPosition(),%brickLook.getPosition());
			}
	}

	%pathCam.pushBack(%transform,%speed,"Position Only","Spline");
	%pathCam.node[%pathCam.nodeNum++] = %transform;


	if(%pathCam.node[1] !$= %transform)
	{
		while(%pathCam.node[1] !$= %transform)
		{
			for(%i=1;%i<=%pathCam.nodeNum;%i++)
			{
				%pathCam.node[%i] = %pathCam.node[%i + 1];
			}
			%pathCam.node[%i] = "";
			%pathCam.popFront();
			%pathCam.nodeNum--;
		}
	}
	if(!%found)
	{
		%pathCam.popFront();
	}

	%pathCam.pushBack(%transform2,%speed,"Position Only","Spline");
	%pathCam.node[%pathCam.nodeNum++] = %newBrick.getPosition() SPC rotBetween(%this.getPosition(),%newBrick.getPosition());
	%pathCam.setTarget(%pathCam.nodeNum);

	%client.isCamBusy = 1;
	%client.pathCam = %pathCam;
	%pathCam.isBusy = 1;
	%client.setControlObject(%pathCam);
	%client.lastDestBrick = %newBrick;
	%client.lastDestLook = %transform2;
	%client.lastPathTrip = getSimTime();
	

	%time = 0;
	if(%pathCam.hasBeenUsed == 0)
	{
		%client.bottomPrint("\c2*Initiating Camera*",2);
		%time = 3000;
		%pathCam.hasBeenUsed = 1;
	}

	%pathCam.setState("stop");
	%pathCam.setPosition(0.0);

	schedule(%time,0,finishPathCamSend,%pathCam,%client,%this.getPosition(),%newBrick.getPosition(),%speed, %newBrick);
}

function finishPathCamSend(%cam,%client,%posA,%posB,%speed,%newBrick)
{
	%cam.setState("stop");
	%cam.setPosition(0.0);

	%cam.schedule(100,setState,"forward");

	%dist = vectorDist(%posA,%posB);
	%totalTime = ((%dist * 1000) / %speed) + 100;

	%client.inputSendSched = %newBrick.schedule(%totalTime,"onPathCameraReceived",%client);

	schedule(%totalTime,0,finishPathCam,%cam,%client);
	%client.setCOSched = %client.schedule(%totalTime,"setControlToPlayer");
}
function fxDtsBrick::onPathCameraReceived(%this,%client)
{
	$InputTarget_["Self"]   = %this;
	$InputTarget_["Player"] = %client.player;
	$InputTarget_["Client"] = %client;

	if($Server::LAN)
	{
		$InputTarget_["MiniGame"] = getMiniGameFromObject(%client);
	}
	else
	{
		if(getMiniGameFromObject(%this) == getMiniGameFromObject(%client))
		{
			$InputTarget_["MiniGame"] = getMiniGameFromObject(%this);
		}
		else
		{
			$InputTarget_["MiniGame"] = 0;
		}
	}

	//process the event
	%this.processInputEvent("onPathCameraReceived", %client);
}

function finishPathCam(%cam,%client)
{
	%cam.setState("stop");
	%cam.isBusy = 0;

	%client.isCamBusy = 0;
}
function GameConnection::setControlToPlayer(%this)
{
	%this.setControlObject(%this.player);
}


//Support

function eulerToAxis(%euler)
{
	%euler = VectorScale(%euler,$pi / 180);
	%matrix = MatrixCreateFromEuler(%euler);
	return getWords(%matrix,3,6);
}

//Thanks Truce
function rotBetween(%a,%b)
{
	%v = vectorNormalize(vectorSub(%b,%a));
	%x = getWord(%v,0);
	%y = getWord(%v,1);
	
	%yaw   = mATan(%x,%y) - $pi / 2;
	%pitch =   0 - mATan(getWord(%v,2),mSqrt(%x * %x + %y * %y));
	%xy    =   0 - %pitch * 180 / $pi;
	%z     = -90 - %yaw   * 180 / $pi;
	
	return eulerToAxis(%xy SPC 0 SPC %z);
}


//Taken and edited from Chrono's Camera Events Mod, thanks Chrono!
//Functions that will stop camera views.
package EventCam
{
	//Player death
	function armor::onDisabled(%this,%obj,%state)
	{
		%client = %obj.client;
		%client.setControlObject(%client.player);
		if(isObject(%client.pathCam) && %client.isCamBusy)
		{
			cancel(%client.setCOSched);
			cancel(%client.inputSendSched);
			%client.pathCam.setState("stop");
			%client.pathCam.setPosition(0.0);
			%client.isCamBusy = 0;
			%client.pathCam = "";
			%client.pathCam.isBusy = 0;
		}

		Parent::onDisabled(%this,%obj,%state);
	}
	//Light
	function serverCmdLight(%client)
	{
		if(%client.isCamBusy && $PathCam::LightExit)
		{
			%client.setControlObject(%client.player);
			if(isObject(%client.pathCam))
			{
				cancel(%client.setCOSched);
				cancel(%client.inputSendSched);
				%client.pathCam.setState("stop");
				%client.pathCam.setPosition(0.0);
				%client.pathCam.isBusy = 0;
				%client.pathCam = "";
				%client.isCamBusy = 0;
			}

			return;
		}
		Parent::serverCmdLight(%client);
	}
	//Loss of control
	function GameConnection::setControlObject(%this,%obj)
	{
		if(isObject(%this.pathCam) && %this.getControlObject() == %this.pathCam)
		{
			cancel(%this.setCOsched);
			cancel(%this.inputSendSched);
			%this.pathCam.setState("stop");
			%this.pathCam.setPosition(0.0);
			%this.pathCam.isBusy = 0;
			%this.pathCam = "";
			%this.isCamBusy = 0;
		}
		Parent::setControlObject(%this,%obj);
	}
};
activatePackage(EventCam);